<?php

/**
 * Validates an Email Adress
 * 
 * @param string | $ Email to Validate
 * @return boolean
 */
function isEmail($value) {
	
	// in case value is several addresses separated by newlines
	$_addresses = preg_split ( '![\n\r]+!', $value );
	
	foreach ( $_addresses as $_address ) {
		$_is_valid = ! (preg_match ( '!@.*@|\.\.|\,|\;!', $_address ) || ! preg_match ( '!^.+\@(\[?)[a-zA-Z0-9\.\-]+\.([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$!', $_address ));
		
		if (! $_is_valid)
			return false;
	}
	return true;
}

/**
 * Extracts all emails foun in a string
 * 
 * @param string | $ string to extract emails from
 * @return array
 */
function extract_emails($str) {
	$regexp = '/([a-z0-9_\.\-])+\@(([a-z0-9\-])+\.)+([a-z0-9]{2,4})+/i';
	preg_match_all ( $regexp, $str, $m );
	
	return isset ( $m [0] ) ? $m [0] : array ();
}

/**
 * Validates an URL
 * 
 * @param string | $ URL to Validate
 * @return boolean
 */
function isURL($value) {
	return preg_match ( '!^http(s)?://[\w-]+\.[\w-]+(\S+)?$!i', $value );
}

/**
 * Remove empty values of an array
 * 
 * @param array | Array to parse
 * @return array
 */
function array_remove_empty_string(array $arr) {
	$narr = array ();
	$val = '';
	while ( list ( $key, $val ) = each ( $arr ) ) {
		if (is_array ( $val )) {
			$val = array_remove_empty_string ( $val );
			// does the result array contain anything?
			if (count ( $val ) != 0) {
				// yes :-)
				$narr [$key] = $val;
			}
		} else {
			if (trim ( $val ) != "") {
				$narr [$key] = $val;
			}
		}
	}
	unset ( $arr );
	return $narr;
}

function IsIPValid($ip) {
	if (preg_match ( '/^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$/', $ip ))
		return true;
	
	return false;
}

/* Validates an URL
 * 
 * @param string | $ time range
 * @param string | $ time stamp
 * @return boolean
 * 
 *  
 *  short checks:
 *  if (time_is_older_than('10s', $time)){ print "Is older than 10 seconds<br/>\n"; }
 *  if (time_is_older_than('200m', $time)){ print "Is older than 200 minutes<br/>\n"; }
 *  if (time_is_older_than('2h', $time)){ print "Is older than 2 hours<br/>\n"; }
 *  if (time_is_older_than('4d', $time)){ print "Is older than 4 days<br/>\n"; }
 *  if (time_is_older_than('1y', $time)){ print "Is older than one year<br/>\n"; }
*/
function time_is_older_than(stemp &$stemp, $t, $check_time) {
	
	$t = strtolower ( $t );
	$time_type = substr ( preg_replace ( '/[^a-z]/', '', $t ), 0, 1 );
	$val = intval ( preg_replace ( '/[^0-9]/', '', $t ) );
	$ts = 0;
	
	// (s)econds, (m)inutes, (d)ays, (y)ears
	if ($time_type == 's') {
		$ts = $val;
	} else if ($time_type == 'm') {
		$ts = $val * 60;
	} else if ($time_type == 'h') {
		$ts = $val * 60 * 60;
	} else if ($time_type == 'd') {
		$ts = $val * 60 * 60 * 24;
	} else if ($time_type == 'y') {
		$ts = $val * 60 * 60 * 24 * 365;
	} else {
		$stemp->trigger_error ( _ ( "Unknown time format given!" ) );
	
	}
	
	if ($check_time < (time () - $ts))
		return true;
	
	return false;
}

?>